% Liu Xingsi <liu_xingsi@u.nus.edu>
% National University of Singapore
% Created for: Relative-phase simulated annealing lenses design (2022)
function [F_all,focus_prof] = Scalar_2d_3FWHM(rho, P)
    F_all = zeros(P.lambda_n,1);
    focus_prof = cell(P.lambda_n,1);
    height=rho(min(P.phi,length(rho)))*P.gh/P.hlvl_n;
    for wvn_idx = 1:P.lambda_n
        lambda_now = P.lambda(wvn_idx);
        phi1 = 2*pi*(height*(P.ng(wvn_idx)-1)+P.gh)/lambda_now; 
        u1=exp(1i*phi1);
        u1_l=zeros(P.scale2d*size(u1));
        range_u1=length(u1_l)/2-length(u1)/2+1:length(u1_l)/2+length(u1)/2;
        u1_l(range_u1,range_u1)=u1;
        u1_l = repelem(u1_l,P.rep_n,P.rep_n);
        range_u1=length(u1_l)/2-round(length(u1)*P.rep_n/2)+1:length(u1_l)/2+round(length(u1)*P.rep_n/2);
        u1_l(range_u1,range_u1)=u1_l(range_u1,range_u1).*P.circule_mask;
        focus_prof_temp=propRS(u1_l,P.D*P.scale2d,lambda_now,P.FL);
        focus_prof{wvn_idx}=focus_prof_temp(range_u1,range_u1);
        F_all(wvn_idx)=calculate_eff_2d_3FHWM(focus_prof{wvn_idx}, P.PE*P.rep_n^2,P.FWHMi(wvn_idx),P);
    end
end
%% 


