% Liu Xingsi <liu_xingsi@u.nus.edu>
% National University of Singapore
% Created for: Relative-phase simulated annealing lenses design (2022)
function [Eff,FHWM]=calculate_eff_1d_3FHMW(E_focal_z,P)
    [v,idx_max] = max(abs(E_focal_z));
    if(abs(idx_max-length(E_focal_z)/2)>3)
        idx_max=round(length(E_focal_z)/2);
    end
    idx_mid_right1 = idx_max;
    idx_mid_left1 = idx_max;
    for idx = 1:idx_max-1
        if(abs(E_focal_z(idx_max-idx))<v/sqrt(2))
            idx_mid_left1 = idx_max-idx+1;
            break
        end
    end
    for idx = 2:idx_max-1
        if(abs(E_focal_z(idx_max+idx))<v/sqrt(2))
            idx_mid_right1 = idx_max+idx;
            break
        end
    end
    a1=abs(E_focal_z(idx_mid_right1)/E_focal_z(idx_max))^2;
    a2=abs(E_focal_z(idx_mid_right1-1)/E_focal_z(idx_max))^2;
    idx_mid_right2=idx_mid_right1-(0.5-a1)/(a2-a1);
    a1=abs(E_focal_z(idx_mid_left1)/E_focal_z(idx_max))^2;
    a2=abs(E_focal_z(idx_mid_left1-1)/E_focal_z(idx_max))^2;
    idx_mid_left2=idx_mid_left1-(0.5-a1)/(a2-a1);    
    FHWM = max(idx_mid_right2-idx_mid_left2,0);
    idx_mid_right = round(idx_max+P.FWHMi*P.rep_n*1.5/P.unit_size);
    idx_mid_left = round(idx_max-P.FWHMi*P.rep_n*1.5/P.unit_size);
    a=abs(E_focal_z(idx_mid_left:idx_mid_right)).^2;
    b=abs(E_focal_z(:)).^2;
    % ASSUMPTION: transmission rate = 1
    Eff = sum(a)/sum(b);
end


% function [Eff]=calculate_eff_1d_3FHMW(E_focal_z,FHWM1,P)
%     idx_max = round(length(E_focal_z)/2);
%     idx_mid_right = round(idx_max+FHWM1*P.rep_n*1.5/P.unit_size);
%     idx_mid_left = round(idx_max-FHWM1*P.rep_n*1.5/P.unit_size);
%     a=abs(E_focal_z(idx_mid_left:idx_mid_right)).^2;
%     b=abs(E_focal_z(:)).^2;
%     % ASSUMPTION: transmission rate = 1
%     Eff = sum(a)/sum(b);
% %     figure(11), plot(abs(E_focal_z.^2))
% end