% Liu Xingsi <liu_xingsi@u.nus.edu>
% National University of Singapore
% Created for: Relative-phase simulated annealing lenses design (2022)
function Eff=calculate_eff_2d_3FHWM(E,PE,FHWM1,P)
    E=abs(E.^2);
%     E=E/max(max(E));
    idx_max = round(length(E)/2);
%     [~,idx_max] = max(E_focal_z);%round(length(E_focal_z)/2);
    idx_mid_right = round(idx_max+FHWM1*P.rep_n*1.5/P.unit_size);
    idx_mid_left = round(idx_max-FHWM1*P.rep_n*1.5/P.unit_size);
    x1 = 1:length(E);
    [P.X,P.Y]=meshgrid(x1,x1);
    r = (idx_mid_right-idx_mid_left)/2;
    R = sqrt((P.X-(idx_max+0.5)).^2+(P.Y-(idx_max+0.5)).^2);
    E_first_lobe = (R<r).*E;
    Eff = sum(sum(E_first_lobe))/PE;
end
