% Liu Xingsi <liu_xingsi@u.nus.edu>
% National University of Singapore
% Created for: Relative-phase simulated annealing lenses design (2022)
%% set up diameter
lambda_min = 8*um;
lambda_max = 12*um;
P.lambda_n=2;
%% set up band
P.unit_n=100; 
P.unit_size = 10*um;
P.D = P.unit_n*P.unit_size;
%% set up material and height
P.gh = 10*um;
P.ng = 3.42;
P.hlvl_n=16; %number of height level
P.FL = P.unit_n*P.unit_size*1.25; %focal length
%% set up 
P.plvl_n=30; %number of phase level
%% set up simulated annealing parameters
epoch_max=500000;
temp_max=500;
temp = temp_max:-temp_max*5/epoch_max:0;
temp=temp.^2/(max(temp)^2)*temp_max;
temp(length(temp)+1:epoch_max)=zeros(epoch_max-length(temp),1);
P.weight=10000;
P.weight=P.weight*P.unit_n^(0.5)*P.lambda_n;% larger converge faster
%% 
epoch_mod=10000; % print at number of epochs runned

