% Liu Xingsi <liu_xingsi@u.nus.edu>
% National University of Singapore
% Created for: Relative-phase simulated annealing lenses design (2022)
plot_fl_l_n=0;
P.rep_n=3;
P.scale1d=1;
P.scale2d=1;
Plambda_n=P.lambda_n;
close all;
fprintf('lambda number %d\n',P.lambda_n);
fprintf('unit n %d\n',P.unit_n);
rho_test=rho_best;
plt_clm_num=round(sqrt(P.lambda_n));
Plot_resl_set_up;

%% plot sturcture
figure(11),
b = bar(rho_test,'hist');
b.EdgeColor = 'none';
b.FaceColor = [0.3 0.3 0.3];
xlim([1,P.unit_n]);
%% 
Eff2d_1d=zeros(P.lambda_n,1);
FWHM1d=zeros(P.lambda_n,1);
focus_prof2d_1d=cell(P.lambda_n,1);
%% 
FWHM_5=round(5*P.lambda(1)/P.unit_size/(2*P.NA))*P.rep_n;
zoom_idx =floor(P.unit_n1*0.5-FWHM_5):floor(P.unit_n1*0.5+FWHM_5)+1;
%% 2D
[Eff2d, focus_prof_tmp] = Scalar_2d_3FWHM(rho_test, P);
fprintf('2d: min, %.1f, max, %.1f, mean, %.1f\n',min(Eff2d)*100,max(Eff2d)*100,mean(Eff2d)*100);% 3FWHM
%% 
for wvn_idx = 1:P.lambda_n
    focus_prof_tmp{wvn_idx}=(abs(focus_prof_tmp{wvn_idx}).^2);
end 
P.unit_n1=length(focus_prof_tmp{1});

num_range = max(zoom_idx)-min(zoom_idx);
x_label_size = 0.5*num_range/P.rep_n/P.unit_n*P.D*10^6;
x_label_range=-x_label_size:x_label_size*2/(num_range):x_label_size;
%% 
figure(233),
for wvn_idx = 1:P.lambda_n
    subplot(ceil(P.lambda_n/plt_clm_num),plt_clm_num,wvn_idx)
    surf(x_label_range,x_label_range,focus_prof_tmp{wvn_idx}(zoom_idx,zoom_idx),'EdgeColor','none');view(2);colormap hot;%shading interp;
    xlim([-x_label_size,x_label_size])
    ylim([-x_label_size,x_label_size])
    set(gca,'xtick',[])
    set(gca,'ytick',[])
end
set(gcf,'Position',[100 100 1000 1000])
sgtitle(strcat('Normalized 2D PSF, x in um, eff range: ',num2str(round(min(Eff2d)*100,1)),'-',num2str(round(max(Eff2d)*100,1)),'%, mean: ',num2str(round(mean(Eff2d)*100,1)),'%'));

%% 2D-1D
for wvn_idx = 1:P.lambda_n
    focus_prof2d_1d{wvn_idx}=focus_prof_tmp{wvn_idx}(round(P.unit_n1/2),:);
    [Eff2d_1d(wvn_idx),FWHM1d(wvn_idx)] = calculate_eff_1d_3FHMW(sqrt(focus_prof2d_1d{wvn_idx}),P);
end
%% 
figure(3),
for wvn_idx = 1:P.lambda_n
    subplot(ceil(P.lambda_n/plt_clm_num),plt_clm_num,wvn_idx)
    plot(x_label_range,focus_prof2d_1d{wvn_idx}(zoom_idx)/max(focus_prof2d_1d{wvn_idx}(zoom_idx)),'LineWidth',1.5)
    title(round(P.lambda(wvn_idx)*10^6,1))
    set(gca,'xtick',[])
    set(gca,'ytick',[])
end
set(gcf,'Position',[100 100 1000 1000])
sgtitle('Normalized 2D-1D PSF, x in um,');
%% 
figure(100),close figure 100
figure(100),
plot(P.lambda*10^6,FWHM1d*P.unit_size/P.rep_n*10^6,'LineWidth',1.5)
hold on 
plot(P.lambda*10^6,P.FWHMi*10^6,'LineWidth',1.5)
ylim([0,1.2*max(FWHM1d*P.unit_size/P.rep_n*10^6)])
xlabel('wavelength in um');
ylabel('FWHM in um');
FWHM1d(FWHM1d==0)=[];
fprintf('mean FWHM : %.1f um\n',mean(FWHM1d*P.unit_size/P.rep_n)*10^6)
legend('optimized','ideal');
title(strcat('mean FWHM : ',num2str(round(mean(FWHM1d*P.unit_size/P.rep_n)*10^6,1)),' um'))

%% 
figure(102),close figure 102
figure(102),
plot(Eff2d,'LineWidth',2)
title(strcat('3FWHM focusing efficiency, 2d,  ',num2str(round(mean(Eff2d)*100,1)),'%'))
xlabel('wavelength in um');
ylabel('efficiency');
ylim([0,0.7])

