% Liu Xingsi <liu_xingsi@u.nus.edu>
% National University of Singapore
% Created for: Relative-phase simulated annealing lenses design (2022)
clear
close all
addpath("M_file");
tic
%% 
um=10^-6;
set_up_user_define;       
%% 
set_up;
%% 
[~,FOM] = best_p(p_dist,fx,P);
fprintf('unit n, %d, lambda n, %d, lambda min %.3f\n',P.unit_n, P.lambda_n, lambda_min*10^6);
%% 
while(epoch < epoch_max)
    p_dist_next = find_neighbour_rand(p_dist, P, epoch);
    [~,FOM_next] = best_p(p_dist_next,fx,P);
    prob=Proba(FOM, FOM_next, temp(epoch), P);
    if (rand() < prob)
        p_dist = p_dist_next;
        FOM = FOM_next;
    end
    save_epoch;
    if(FOM>f_best)
        p_dist_best= p_dist;
        f_best = FOM;
    end
end
    %% 
[hlvl,~] = best_p(p_dist_best,fx,P);
hlvl=hlvl-1;
rho_opt_matrix=[flip(hlvl',1);hlvl'];
% toc
%% 
rho_best=rho_opt_matrix;
Plot_resl;
 

