% Liu Xingsi <liu_xingsi@u.nus.edu>
% National University of Singapore
% Created for: Relative-phase simulated annealing lenses design (2022)
function [plvl,FOM]= best_p(p_dist,fx,P)
    opt_p=zeros(P.hlvl_n+1,P.unit_n/2,P.lambda_n);
    for lambda_idx =1: length(P.lambda)
        k = 2*pi/P.lambda(lambda_idx);
        opt_p(:,:,lambda_idx)=exp(1i*k*fx+1i*p_dist(lambda_idx)/P.plvl_n*2*pi);
    end
    %% 
    opt_p_sum=sum(opt_p,3);
    %% 
    opt_p_sum=real(opt_p_sum);
    [value,plvl]=max(opt_p_sum,[],1);
    FOM=mean(value);
end